Attribute VB_Name = "mdlAlgorithms"
Option Explicit

Public m_uSize As Long
Public m_fHillMin As Single
Public m_fHillMax As Single
Public m_bIsland As Boolean
Private src() As Long
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long

Public myPallette(256) As Long


'//Hill algorithm

Public Sub Generate(intHills As Integer)
    Dim I As Long
    Dim X As Long, Y As Long
    Dim lngColor As Long
    
'    m_uSize = 400
'    m_fHillMin = 5
'    m_fHillMax = 100
    Call Clear
    
    For I = 0 To intHills
        AddHill
    Next I
    
   
    Dim Min As Single, Max As Single
    Dim sngCalc As Single, sngRGB As Long
    Max = 0
    Min = 65535
    
    For X = 0 To m_uSize
        For Y = 0 To m_uSize
            lngColor = src(X, Y)
            If lngColor < Min Then Min = lngColor
            If lngColor > Max Then Max = lngColor
        Next Y
    Next X
    
    Dim R As Long, B As Long, G As Long
    
    For X = 0 To m_uSize
        For Y = 0 To m_uSize
            'If src(X, Y) > 0 Then
                sngCalc = (256 * (src(X, Y) - Min) / (Max - Min))
         '   Debug.Print sngCalc
            'End If
            If sngCalc > m_fHillMin Then
                sngRGB = myPallette(sngCalc) 'RGB(sngCalc, sngCalc, sngCalc)
                
                lngColor = GetPixel(frmMain.Picture2.hdc, X, Y)
                
                R = CLng(sngRGB And 255) + CLng(lngColor And 255)
                G = CLng(sngRGB And 65280) + CLng(lngColor And 65280)
                B = CLng(sngRGB And 16711680) + CLng(lngColor And 16711680)
                R = R / 2
                G = G / 2 / 256
                B = B / 2 / 65536
                
                'lngColor = sngRGB * 0.5 + lngColor * 0.5
                Call SetPixel(frmMain.Picture2.hdc, X, Y, RGB(R, G, B))
                
            End If
        Next Y
    Next X
    
    
    
End Sub

Private Sub Clear()
    Dim X As Long, Y As Long
        
    '//Create a hill
    ReDim src(m_uSize, m_uSize) As Long
    
End Sub

Private Sub AddHill()
    Dim fRadius As Single
    Dim sngX As Single, sngY As Single
    
    
    Dim fTheta As Single
    Dim fDistance As Single
    Dim fRadiusSq As Single
    Dim fDistSq As Single
    Dim fHeight As Single
    Dim xMin As Long, xMax As Long
    Dim yMin As Long, yMax As Long
    Dim h As Long, v As Long
    
    '// pick a size for the hill
    fRadius = RandomRange(m_fHillMin, m_fHillMax)
    'm_bIsland = True
    '// pick a centerpoint for the hill
    If m_bIsland = True Then
        '// island code:
        
        fTheta = RandomRange(0, 15)
        '// this determines in which direction from the center of the map the
        '// hill will be placed.
        
        fDistance = RandomRange(fRadius / 2, m_uSize / 2 - fRadius)
        '// this is how far from the center of the map the hill be placed. note
        '// that the radius of the hill is subtracted from the range to prevent
        '// any part of a hill from reaching the very edge of the map.
        
        sngX = m_uSize / 2 + Cos(fTheta) * fDistance
        sngY = m_uSize / 2 + Sin(fTheta) * fDistance
        '// converts theta and a distance into x and y coordinates.
    Else
        '// non-island code:
        
        sngX = -RandomRange(-fRadius, m_uSize / 2 - fRadius)
        sngY = -RandomRange(-fRadius, m_uSize / 2 - fRadius)
        '// note that the range of the hill is used to determine the
        '// centerpoint. this allows hills to have their centerpoint off the
        '// edge of the terrain as long as part of the hill is in bounds. this
        '// makes the terrains appear continuous all the way to the edge of the
        '// map.
    End If

    '// square the hill radius so we don't have to square root the distance
    fRadiusSq = fRadius * fRadius
    
    '// find the range of cells affected by this hill
    xMin = sngX - fRadius - 1
    xMax = sngX + fRadius + 1
    
    '// don't affect cell outside of bounds
    If xMin < 0 Then xMin = 0
    If xMax >= m_uSize Then xMax = m_uSize - 1
    
    yMin = sngY - fRadius - 1
    yMax = sngY + fRadius + 1
    
    '// don't affect cell outside of bounds
    
    If yMin < 0 Then yMin = 0
    If yMax >= m_uSize Then yMax = m_uSize - 1
    
    '// for each affected cell, determine the height of the hill at that point
    '// and add it to that cell
    
    For h = xMin To xMax Step 1
        For v = yMin To yMax Step 1
            '// determine how far from the center of the hill this point is
            fDistSq = (sngX - h) * (sngX - h) + (sngY - v) * (sngY - v)
             
            '// determine the height of the hill at this point
            fHeight = fRadiusSq - fDistSq
          '  Debug.Print fHeight
            '// don't add negative hill values (i.e. outside the hill's radius)
            If fHeight > 0 Then
                '// add the height of this hill to the cell
                'Call OffsetCell(h, v, fHeight)
                
                src(h, v) = src(h, v) + fHeight
            End If
        Next v
    Next h

End Sub

Private Function RandomRange(sngMin As Single, sngMax As Single) As Single
    RandomRange = (Rnd * 128) - (sngMax - sngMin) + sngMin
End Function
